# Contributing to Doctrine Extensions

Thank you for your interest in contributing to Doctrine Extensions!

## Which Branch Should I Contribute To?

All pull requests should target the `master` branch, with a planned 3.0 major release. 

:warning: The `v.2.4.x` branch has been marked as legacy/deprecated.

## Pull Request Titles

Please include the name(s) of the related extensions as a "tag" in the
pull request title.

> [Tree] Add a new Oak Tree branching style
  
## Changelog

All updates must include an entry in the [Changelog](/changelog.md).
Put your entry in the `[Unreleased]` section at the top, under the
corresponding Extension and Category.

If there is a related GitHub issue, add it as a suffix to your change.

```
## [Unreleased]
### Loggable
#### Fixed
- Allow emoji in the docs (#123)
```

## What You Can Contribute

Want to contribute but aren't sure where to start? Check out our
[Issue Board](https://github.com/Atlantic18/DoctrineExtensions/issues)!
There are lots of opportunities for helping other users with their issue,
or contributing a reported bug fix or feature request.
